## getdp 2.9.2+dfsg1

=== CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)

# do not warn about non-definition of WIN32 on cygwin
set(CMAKE_LEGACY_CYGWIN_WIN32 0)

# if CMAKE_BUILD_TYPE is specified use it; otherwise set the default
# build type to "RelWithDebInfo" ("-O2 -g" with gcc) prior to calling
# project()
if(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "Choose build type")
else(DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose build type")
endif(DEFINED CMAKE_BUILD_TYPE)

# this variable controls the default value of the options which are normally set
# to ON (useful if you want to configure a minimal version of GetDP: e.g. "cmake
# -DDEFAULT=0 -DENABLE_PETSC=1")
set(DEFAULT ON CACHE INTERNAL "Default value for enabled-by-default options")

macro(opt OPTION HELP VALUE)
  option(ENABLE_${OPTION} ${HELP} ${VALUE})
  set(OPT_TEXI "${OPT_TEXI}\n@item ENABLE_${OPTION}\n${HELP} (default: ${VALUE})")
endmacro(opt)

opt(ARPACK "Enable Arpack eigensolver (requires Fortran)" ${DEFAULT})
opt(CONTRIB_ARPACK "Enable Arpack eigensolver from GetDP's contrib folder (requires Fortran)" OFF)
opt(BLAS_LAPACK "Enable BLAS/Lapack for linear algebra (e.g. for Arpack)" ${DEFAULT})
opt(BUILD_LIB "Enable 'lib' target for building static GetDP library" OFF)
opt(BUILD_SHARED "Enable 'shared' target for building shared GetDP library" OFF)
opt(BUILD_DYNAMIC "Enable dynamic GetDP executable (linked with shared lib)" OFF)
opt(BUILD_ANDROID "Enable Android NDK library target (experimental)" OFF)
opt(BUILD_IOS "Enable iOS (ARM) library target (experimental)" OFF)
opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
opt(KERNEL "Enable kernel (required for actual computations)" ON)
opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
opt(MULTIHARMONIC "Enable multi-harmonic support" OFF)
opt(NR "Enable NR functions (if GSL is unavailable)" ${DEFAULT})
opt(NX "Enable proprietary NX extension" OFF)
opt(OCTAVE "Enable Octave functions" OFF)
opt(OPENMP "Enable OpenMP parallelization of some functions (experimental)" OFF)
opt(PETSC "Enable PETSc linear solver" ${DEFAULT})
opt(PYTHON "Enable Python functions" ${DEFAULT})
opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
opt(SMALLFEM "Enable experimental SmallFem assembler" OFF)
opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
opt(WRAP_PYTHON "Build Python wrappers" OFF)
opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)

if(ENABLE_FORTRAN)
  project(getdp CXX C Fortran)
else(ENABLE_FORTRAN)
  project(getdp CXX C)
endif(ENABLE_FORTRAN)

set(GETDP_MAJOR_VERSION 2)
set(GETDP_MINOR_VERSION 9)
set(GETDP_PATCH_VERSION 2)
set(GETDP_EXTRA_VERSION "" CACHE STRING "GetDP extra version string")

set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
set(GETDP_VERSION "${GETDP_VERSION}.${GETDP_PATCH_VERSION}${GETDP_EXTRA_VERSION}")
set(GETDP_SHORT_LICENSE "GNU General Public License")

set(GETDP_API
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPConfig.h
  ${CMAKE_CURRENT_BINARY_DIR}/Common/GetDPVersion.h
  Kernel/GetDP.h
)

execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME
                OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER
                OUTPUT_STRIP_TRAILING_WHITESPACE)

if(NOT DATE)
  set(DATE "unknown")
endif(NOT DATE)
set(GETDP_DATE "${DATE}")

if(NOT HOSTNAME)
  set(HOSTNAME "unknown")
endif(NOT HOSTNAME)
set(GETDP_HOST "${HOSTNAME}")

if(NOT PACKAGER)
  set(PACKAGER "unknown")
endif(NOT PACKAGER)
set(GETDP_PACKAGER "${PACKAGER}")

if(APPLE)
  set(GETDP_OS "MacOSX")
elseif(CYGWIN)
  set(GETDP_OS "Windows")
else(APPLE)
  set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
endif(APPLE)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXCompilerFlag)

if(ENABLE_WRAP_PYTHON AND NOT ENABLE_BUILD_SHARED)
  set(ENABLE_BUILD_DYNAMIC ON)
endif(ENABLE_WRAP_PYTHON AND NOT ENABLE_BUILD_SHARED)

if(MSVC)
  if(ENABLE_MSVC_STATIC_RUNTIME)
    foreach(VAR
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
      if(${VAR} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${VAR} "${${VAR}}")
      endif(${VAR} MATCHES "/MD")
    endforeach(VAR)
  endif(ENABLE_MSVC_STATIC_RUNTIME)
endif(MSVC)

if(ENABLE_OPENMP)
  find_package(OpenMP)
  if(OPENMP_FOUND)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  endif(OPENMP_FOUND)
endif(ENABLE_OPENMP)

macro(append_getdp_src DIRNAME FILES)
  foreach(FILE ${FILES})
    list(APPEND LIST ${DIRNAME}/${FILE})
  endforeach(FILE)
  set(GETDP_SRC ${GETDP_SRC};${LIST} PARENT_SCOPE)
  set(GETDP_DIRS ${GETDP_DIRS};${DIRNAME} PARENT_SCOPE)
endmacro(append_getdp_src)

macro(find_all_libraries VARNAME LISTNAME PATH SUFFIX)
  set(${VARNAME})
  list(LENGTH ${LISTNAME} NUM_LIST)
  foreach(LIB ${${LISTNAME}})
    if("${PATH}" STREQUAL "")
      find_library(FOUND_LIB ${LIB} PATH_SUFFIXES ${SUFFIX})
    else("${PATH}" STREQUAL "")
      find_library(FOUND_LIB ${LIB} PATHS ${PATH} NO_DEFAULT_PATH)
    endif("${PATH}" STREQUAL "")
    if(FOUND_LIB)
      list(APPEND ${VARNAME} ${FOUND_LIB})
    endif(FOUND_LIB)
    unset(FOUND_LIB CACHE)
  endforeach(LIB)
  list(LENGTH ${VARNAME} NUM_FOUND_LIBRARIES)
  if(NUM_FOUND_LIBRARIES LESS NUM_LIST)
    set(${VARNAME})
  endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
endmacro(find_all_libraries)

macro(set_config_option VARNAME STRING)
  set(${VARNAME} TRUE)
  list(APPEND CONFIG_OPTIONS ${STRING})
  message(STATUS "Found " ${STRING})
endmacro(set_config_option)

# check if the machine is 64 bits (this is more reliable than using
# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
# machines)
check_type_size("void*" SIZEOF_VOID_P)
if(SIZEOF_VOID_P EQUAL 8)
  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
endif(SIZEOF_VOID_P EQUAL 8)

if(ENABLE_BLAS_LAPACK)
  if(BLAS_LAPACK_LIBRARIES)
    # use libs as specified in the BLAS_LAPACK_LIBRARIES variable
    set_config_option(HAVE_BLAS "Blas(Custom)")
    set_config_option(HAVE_LAPACK "Lapack(Custom)")
    set(LAPACK_LIBRARIES ${BLAS_LAPACK_LIBRARIES})
  else(BLAS_LAPACK_LIBRARIES)
    if(MSVC)
      # on Windows with Visual C++ try really hard to find blas/lapack *without*
      # requiring a Fortran compiler: 1) try to find the Intel MKL libs using
      # the standard search path; if not found 2) try to get the reference
      # blas/lapack libs (useful for users with no Fortran compiler and no MKL
      # license, who can just download our precompiled "gmsh-dep" package)
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH em64t/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_lp64 mkl_intel_thread mkl_core)
      else(HAVE_64BIT_SIZE_T)
        set(MKL_PATH ia32/lib)
        set(MKL_LIBS_REQUIRED libguide40 mkl_intel_c mkl_intel_thread mkl_core)
      endif(HAVE_64BIT_SIZE_T)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(IntelMKL)")
        set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
      else(LAPACK_LIBRARIES)
        set(REFLAPACK_LIBS_REQUIRED lapack blas g2c gcc)
        find_all_libraries(LAPACK_LIBRARIES REFLAPACK_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas(Reference)")
          set_config_option(HAVE_LAPACK "Lapack(Reference)")
        endif(LAPACK_LIBRARIES)
      endif(LAPACK_LIBRARIES)
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
      # on Linux try to find the Intel MKL without a Fortran compiler
      if(HAVE_64BIT_SIZE_T)
        set(MKL_PATH lib/em64t)
      else(HAVE_64BIT_SIZE_T)
        set(MKL_PATH lib/32)
      endif(HAVE_64BIT_SIZE_T)
      set(MKL_LIBS_REQUIRED mkl_gf_lp64 iomp5 mkl_gnu_thread mkl_core guide pthread)
      find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      if(NOT LAPACK_LIBRARIES)
        # match lapack 9.0 on 64bit
        set(MKL_LIBS_REQUIRED mkl_lapack mkl_em64t guide)
        find_all_libraries(LAPACK_LIBRARIES MKL_LIBS_REQUIRED "" ${MKL_PATH})
      endif(NOT LAPACK_LIBRARIES)
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(IntelMKL)")
        set_config_option(HAVE_LAPACK "Lapack(IntelMKL)")
      else(LAPACK_LIBRARIES)
        # on Linux also try to find ATLAS without a Fortran compiler, because
        # cmake ships with a buggy FindBLAS e.g. on Ubuntu Lucid Lynx
        set(ATLAS_LIBS_REQUIRED lapack f77blas cblas atlas)
        find_all_libraries(LAPACK_LIBRARIES ATLAS_LIBS_REQUIRED "" "")
        if(LAPACK_LIBRARIES)
          set_config_option(HAVE_BLAS "Blas(ATLAS)")
          set_config_option(HAVE_LAPACK "Lapack(ATLAS)")
        else(LAPACK_LIBRARIES)
          # try with generic names
          set(GENERIC_LIBS_REQUIRED lapack blas pthread)
          find_all_libraries(LAPACK_LIBRARIES GENERIC_LIBS_REQUIRED "" "")
          if(LAPACK_LIBRARIES)
            set_config_option(HAVE_BLAS "Blas(Generic)")
            set_config_option(HAVE_LAPACK "Lapack(Generic)")
            find_library(GFORTRAN_LIB gfortran)
            if(GFORTRAN_LIB)
              list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
            endif(GFORTRAN_LIB)
          endif(LAPACK_LIBRARIES)
        endif(LAPACK_LIBRARIES)
      endif(LAPACK_LIBRARIES)
    elseif(${CMAKE_SYSTEM_NAME} MATCHES "SunOS")
      # on SunOS we know blas and lapack are available in sunperf
      set(LAPACK_FLAGS -library=sunperf)
      set_config_option(HAVE_BLAS "Blas(SunPerf)")
      set_config_option(HAVE_LAPACK "Lapack(SunPerf)")
    elseif(APPLE)
      # on Mac we also know that blas and lapack are available
      set(LAPACK_LIBRARIES "-llapack -lblas")
      set_config_option(HAVE_BLAS "Blas(VecLib)")
      set_config_option(HAVE_LAPACK "Lapack(VecLib)")
    endif(MSVC)

    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
      # if we haven't found blas and lapack check for OpenBlas
      set(OPENBLAS_LIBS_REQUIRED openblas)
      find_all_libraries(LAPACK_LIBRARIES OPENBLAS_LIBS_REQUIRED "" "")
      if(LAPACK_LIBRARIES)
        set_config_option(HAVE_BLAS "Blas(OpenBlas)")
        set_config_option(HAVE_LAPACK "Lapack(OpenBlas)")
        find_library(GFORTRAN_LIB gfortran)
        if(GFORTRAN_LIB)
          list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
        endif(GFORTRAN_LIB)
      endif(LAPACK_LIBRARIES)  
    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)

    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
      # if we still haven't found blas and lapack, use the standard cmake tests,
      # which require a working Fortran compiler
      enable_language(Fortran)
      find_package(BLAS)
      if(BLAS_FOUND)
        set_config_option(HAVE_BLAS "Blas")
        find_package(LAPACK)
        if(LAPACK_FOUND)
          set_config_option(HAVE_LAPACK "Lapack")
        else(LAPACK_FOUND)
          set(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
        endif(LAPACK_FOUND)
      endif(BLAS_FOUND)
    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
  endif(BLAS_LAPACK_LIBRARIES)
endif(ENABLE_BLAS_LAPACK)

add_subdirectory(Common)
add_subdirectory(Interface)
add_subdirectory(Numeric)

if(ENABLE_KERNEL)
  add_subdirectory(Kernel)
  set_config_option(HAVE_KERNEL "Kernel")

=== Common/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
  ListUtils.cpp
    TreeUtils.cpp avl.cpp
    MallocUtils.cpp
    Message.cpp
    OS.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h) 
append_getdp_src(Common "${SRC};${HDR}")

=== Interface/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
  ProData.cpp
  ProDefine.cpp
  ProParser.yy.cpp
  ProParser.tab.cpp
  MacroManager.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Interface "${SRC};${HDR}")

=== Kernel/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
  MainKernel.cpp
    F_Analytic.cpp F_BiotSavart.cpp F_Coord.cpp F_ExtMath.cpp
      F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
      F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
      F_Gmsh.cpp F_DiffGeom.cpp F_Octave.cpp F_Python.cpp
    BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
      BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
      BF_Facet.cpp BF_Volume.cpp BF_Region.cpp
      BF_Perpendicular.cpp BF_GroupOfEntities.cpp
    GF_Helmholtz.cpp GF_HelmholtzxForm.cpp
      GF_Laplace.cpp GF_LaplacexForm.cpp
    Gauss_Point.cpp
      Gauss_Line.cpp
      Gauss_Triangle.cpp Gauss_Quadrangle.cpp
      Gauss_Tetrahedron.cpp Gauss_Hexahedron.cpp
      Gauss_Prism.cpp Gauss_Pyramid.cpp
    GeoData.cpp
      GeoEntity.cpp
      GeoNormal.cpp
      GeoTree.cpp
    DofData.cpp
      LinAlg.cpp LinAlg_PETSC.cpp LinAlg_SPARSKIT.cpp
    SolvingAnalyse.cpp SolvingOperations.cpp
      Cal_SolutionErrorRatio.cpp
      Operation_TimeLoopAdaptive.cpp
      Operation_IterativeLoopN.cpp
      Operation_IterativeLinearSolver.cpp
      Operation_IterativeTimeReduction.cpp
      Operation_Update.cpp
      Operation_ChangeOfCoordinates.cpp
	  Operation_PostOperation.cpp
      Treatment_Formulation.cpp
        Get_DofOfElement.cpp
        Get_ConstraintOfElement.cpp
          Get_FunctionValue.cpp
          Get_Geometry.cpp
          Get_ElementSource.cpp
        ExtendedGroup.cpp
        Pre_TermOfFemEquation.cpp
          Generate_Network.cpp
        Cal_GalerkinTermOfFemEquation.cpp
        Cal_GlobalTermOfFemEquation.cpp
          Cal_IntegralQuantity.cpp
          Cal_AnalyticIntegration.cpp
          Cal_Quantity.cpp
          Cal_Value.cpp
          Cal_AssembleTerm.cpp
          Cal_PostQuantity.cpp
      MovingBand2D.cpp
      EigenSolve.cpp EigenSolve_ARPACK.cpp EigenSolve_SLEPC.cpp
    Pos_FemInterpolation.cpp
    Pos_Formulation.cpp
      Pos_Print.cpp
        Pos_Element.cpp Pos_Format.cpp Pos_Iso.cpp Pos_Search.cpp
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Kernel "${SRC};${HDR}")

=== Numeric/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
  NumericUtils.cpp
  Adapt.cpp
  Legendre.cpp
  Bessel.cpp
)

if(ENABLE_FORTRAN)
  list(APPEND SRC BesselLib.f)
endif(ENABLE_FORTRAN)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(Numeric "${SRC};${HDR}")

=== contrib/Sparskit/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
  Sparskit.cpp
  blas1.f
  blassm.f
  cmkreord.f
  flu.f
  formats.f
  inout.f
  iters.f
  matvec.f
  reordering.f
  unary.f
  ilut.F
)

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(contrib/Sparskit "${SRC};${HDR}")

=== debian/changelog ===
getdp (2.9.2+dfsg1-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * [04e3ffc] Update build-depends package names.

 -- Anton Gladky <gladk@debian.org>  Thu, 01 Sep 2016 23:06:23 +0200

getdp (2.9.2+dfsg1-1) unstable; urgency=medium

  * [4f026fb] Update d/watch.
  * [0409196] Refresh patch.
  * [e6e3939] Update d/copyright.
  * [747a881] Update d/rules.
  * [06aef20] Apply cme fix dpkg.
  * [cf50fad] Add myself to uploaders.
  * [59e3934] Imported Upstream version 2.9.2+dfsg1

 -- Anton Gladky <gladk@debian.org>  Mon, 22 Aug 2016 21:03:33 +0200

getdp (2.7.0-4) unstable; urgency=medium

  * Team upload.
  * Switch from swig2.0 to swig. (Closes: #823929)

 -- Graham Inggs <ginggs@debian.org>  Tue, 10 May 2016 21:13:22 +0200

getdp (2.7.0-3) unstable; urgency=medium

  * Team upload.
  * No change rebuild to gain dependencies on the newer libpetsc and libslepc
    package names.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 21 Apr 2016 12:40:52 +0000

=== debian/control ===
Source: getdp
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Anton Gladky <gladk@debian.org> 
Section: math
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               gfortran,
               libarpack2-dev,
               libgsl0-dev,
               mpi-default-dev,
               petsc-dev,
               python-dev,
               libslepc3.4.2-dev,
               swig,
               texlive,
               texlive-generic-recommended
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/getdp.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/getdp.git
Homepage: http://www.geuz.org/getdp

Package: getdp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp

Package: getdp-sparskit
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: general environment for the treatment of discrete problems
 GetDP is a general finite element solver using mixed elements to
 discretize de Rham-type complexes in one, two and three dimensions.
 .
 The main feature of GetDP is the closeness between the input data
 defining discrete problems (written by the user in ASCII data files)
 and the symbolic mathematical expressions of these problems.
 .
 See GetDP's reference manual for a more thorough overview of GetDP's
 capabilities: http://www.geuz.org/getdp
 .
 Getdp is compiled with SPARSKIT support

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR_PETSC = $(CURDIR)/debian/build/petsc
BUILDDIR_SPARSKIT = $(CURDIR)/debian/build/sparskit

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt


override_dh_auto_build:
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_PETSC)
	dh_auto_build -O--parallel --builddirectory=$(BUILDDIR_SPARSKIT)
	mv $(BUILDDIR_SPARSKIT)/getdp $(BUILDDIR_SPARSKIT)/getdp-sparskit

override_dh_auto_install:
	dh_auto_install -O--parallel --builddirectory=$(BUILDDIR_PETSC)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR_PETSC) $(BUILDDIR_SPARSKIT)

override_dh_installdocs:
	dh_installdocs --all README.txt

## getdp 2.11.3+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.
@@ -38,6 +38,7 @@
 opt(FORTRAN "Enable Fortran (needed for Arpack/Sparskit/Zitsol & Bessel)" ${DEFAULT})
 opt(GMSH "Enable Gmsh functions (for field interpolation)" ${DEFAULT})
 opt(GSL "Enable GSL functions (for some built-in functions)" ${DEFAULT})
+opt(HPDDM "Enable HPDDM support" ${DEFAULT})
 opt(KERNEL "Enable kernel (required for actual computations)" ON)
 opt(MPI "Enable MPI parallelization (with PETSc/SLEPc)" OFF)
 opt(MULTIHARMONIC "Enable multi-harmonic support" OFF)
@@ -50,6 +51,7 @@
 opt(SLEPC "Enable SLEPc eigensolver" ${DEFAULT})
 opt(SMALLFEM "Enable experimental SmallFem assembler" OFF)
 opt(SPARSKIT "Enable Sparskit solver instead of PETSc (requires Fortran)" ${DEFAULT})
+opt(PEWE "Enable PeWe exact solutions (requires Fortran)" ${DEFAULT})
 opt(WRAP_PYTHON "Build Python wrappers" OFF)
 opt(ZITSOL "Enable Zitsol solvers (requires PETSc and Fortran)" OFF)
 
@@ -60,8 +62,8 @@
 endif(ENABLE_FORTRAN)
 
 set(GETDP_MAJOR_VERSION 2)
-set(GETDP_MINOR_VERSION 9)
-set(GETDP_PATCH_VERSION 2)
+set(GETDP_MINOR_VERSION 11)
+set(GETDP_PATCH_VERSION 3)
 set(GETDP_EXTRA_VERSION "" CACHE STRING "GetDP extra version string")
 
 set(GETDP_VERSION "${GETDP_MAJOR_VERSION}.${GETDP_MINOR_VERSION}")
@@ -74,8 +76,12 @@
   Kernel/GetDP.h
 )
 
-execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
-                OUTPUT_STRIP_TRAILING_WHITESPACE)
+if(${CMAKE_MAJOR_VERSION} GREATER 2)
+  string(TIMESTAMP DATE "%Y%m%d")
+else(${CMAKE_MAJOR_VERSION} GREATER 2)
+  execute_process(COMMAND date "+%Y%m%d" OUTPUT_VARIABLE DATE
+                  OUTPUT_STRIP_TRAILING_WHITESPACE)
+endif(${CMAKE_MAJOR_VERSION} GREATER 2)
 execute_process(COMMAND hostname OUTPUT_VARIABLE HOSTNAME
                 OUTPUT_STRIP_TRAILING_WHITESPACE)
 execute_process(COMMAND whoami OUTPUT_VARIABLE PACKAGER
@@ -86,11 +92,13 @@
 endif(NOT DATE)
 set(GETDP_DATE "${DATE}")
 
-if(NOT HOSTNAME)
-  set(HOSTNAME "unknown")
-endif(NOT HOSTNAME)
-set(GETDP_HOST "${HOSTNAME}")
-
+if(NOT GETDP_HOST)
+  if(NOT HOSTNAME)
+    set(HOSTNAME "unknown")
+  endif(NOT HOSTNAME)
+  set(GETDP_HOST "${HOSTNAME}")
+endif(NOT GETDP_HOST)
+    
 if(NOT PACKAGER)
   set(PACKAGER "unknown")
 endif(NOT PACKAGER)
@@ -100,6 +108,7 @@
   set(GETDP_OS "MacOSX")
 elseif(CYGWIN)
   set(GETDP_OS "Windows")
+  add_definitions(-DWIN32) # recent mingw compiler doesn't define it
 else(APPLE)
   set(GETDP_OS "${CMAKE_SYSTEM_NAME}")
 endif(APPLE)
@@ -108,6 +117,29 @@
 include(CheckFunctionExists)
 include(CheckIncludeFile)
 include(CheckCXXCompilerFlag)
+
+macro(set_config_option VARNAME STRING)
+  set(${VARNAME} TRUE)
+  list(APPEND CONFIG_OPTIONS ${STRING})
+  message(STATUS "Found " ${STRING})
+endmacro(set_config_option)
+
+# check if the machine is 64 bits (this is more reliable than using
+# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
+# machines)
+check_type_size("void*" SIZEOF_VOID_P)
+if(SIZEOF_VOID_P EQUAL 8)
+  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
+endif(SIZEOF_VOID_P EQUAL 8)
+
+# append 32/64 to the build name on Linux and Windows
+if(NOT APPLE)
+  if(HAVE_64BIT_SIZE_T)
+    set(GETDP_OS "${GETDP_OS}64")
+  else(HAVE_64BIT_SIZE_T)
+    set(GETDP_OS "${GETDP_OS}32")
+  endif(HAVE_64BIT_SIZE_T)
+endif(NOT APPLE)
 
 if(ENABLE_WRAP_PYTHON AND NOT ENABLE_BUILD_SHARED)
   set(ENABLE_BUILD_DYNAMIC ON)
@@ -130,8 +162,10 @@
 if(ENABLE_OPENMP)
   find_package(OpenMP)
   if(OPENMP_FOUND)
+    set_config_option(HAVE_OPENMP "OpenMP")
     set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
+    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} ${OpenMP_Fortran_FLAGS}")
   endif(OPENMP_FOUND)
 endif(ENABLE_OPENMP)
 
@@ -163,19 +197,16 @@
   endif(NUM_FOUND_LIBRARIES LESS NUM_LIST)
 endmacro(find_all_libraries)
 
-macro(set_config_option VARNAME STRING)
-  set(${VARNAME} TRUE)
-  list(APPEND CONFIG_OPTIONS ${STRING})
-  message(STATUS "Found " ${STRING})
-endmacro(set_config_option)
-
-# check if the machine is 64 bits (this is more reliable than using
-# CMAKE_SIZEOF_VOID_P, which does not seem to work e.g. on some Suse
-# machines)
-check_type_size("void*" SIZEOF_VOID_P)
-if(SIZEOF_VOID_P EQUAL 8)
-  set_config_option(HAVE_64BIT_SIZE_T "64Bit")
-endif(SIZEOF_VOID_P EQUAL 8)
+macro(set_compile_flags LISTNAME FLAGS)
+  foreach(FILE ${${LISTNAME}})
+    get_source_file_property(PROP ${FILE} COMPILE_FLAGS)
+    if(PROP)
+      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${PROP} ${FLAGS}")
+    else(PROP)
+      set_source_files_properties(${FILE} PROPERTIES COMPILE_FLAGS "${FLAGS}")
+    endif(PROP)
+  endforeach(FILE)
+endmacro(set_compile_flags)
 
 if(ENABLE_BLAS_LAPACK)
   if(BLAS_LAPACK_LIBRARIES)
@@ -265,37 +296,3 @@
       set(OPENBLAS_LIBS_REQUIRED openblas)
       find_all_libraries(LAPACK_LIBRARIES OPENBLAS_LIBS_REQUIRED "" "")
       if(LAPACK_LIBRARIES)
-        set_config_option(HAVE_BLAS "Blas(OpenBlas)")
-        set_config_option(HAVE_LAPACK "Lapack(OpenBlas)")
-        find_library(GFORTRAN_LIB gfortran)
-        if(GFORTRAN_LIB)
-          list(APPEND LAPACK_LIBRARIES ${GFORTRAN_LIB})
-        endif(GFORTRAN_LIB)
-      endif(LAPACK_LIBRARIES)  
-    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-
-    if(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-      # if we still haven't found blas and lapack, use the standard cmake tests,
-      # which require a working Fortran compiler
-      enable_language(Fortran)
-      find_package(BLAS)
-      if(BLAS_FOUND)
-        set_config_option(HAVE_BLAS "Blas")
-        find_package(LAPACK)
-        if(LAPACK_FOUND)
-          set_config_option(HAVE_LAPACK "Lapack")
-        else(LAPACK_FOUND)
-          set(LAPACK_LIBRARIES ${BLAS_LIBRARIES})
-        endif(LAPACK_FOUND)
-      endif(BLAS_FOUND)
-    endif(NOT HAVE_BLAS OR NOT HAVE_LAPACK)
-  endif(BLAS_LAPACK_LIBRARIES)
-endif(ENABLE_BLAS_LAPACK)
-
-add_subdirectory(Common)
-add_subdirectory(Interface)
-add_subdirectory(Numeric)
-
-if(ENABLE_KERNEL)
-  add_subdirectory(Kernel)
-  set_config_option(HAVE_KERNEL "Kernel")

=== Common/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.

=== Interface/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.

=== Kernel/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.
@@ -9,6 +9,7 @@
       F_Geometry.cpp F_Interpolation.cpp F_Hysteresis.cpp F_Math.cpp
       F_Misc.cpp F_MultiHar.cpp F_Raytracing.cpp
       F_Gmsh.cpp F_DiffGeom.cpp F_Octave.cpp F_Python.cpp
+      F_PeWe.cpp
     BF_Node.cpp BF_NodeXYZ.cpp BF_Node_2.cpp BF_Node_3.cpp
       BF_Edge.cpp BF_Edge_2.cpp BF_Edge_3.cpp BF_Edge_4.cpp
       BF_Facet.cpp BF_Volume.cpp BF_Region.cpp
@@ -32,9 +33,10 @@
       Operation_IterativeLoopN.cpp
       Operation_IterativeLinearSolver.cpp
       Operation_IterativeTimeReduction.cpp
-      Operation_Update.cpp
+      Operation_Update.cpp Operation_Vector.cpp
       Operation_ChangeOfCoordinates.cpp
-	  Operation_PostOperation.cpp
+      Operation_PostOperation.cpp
+      Operation_HPDDM.cpp Operation_Debug.cpp
       Treatment_Formulation.cpp
         Get_DofOfElement.cpp
         Get_ConstraintOfElement.cpp
@@ -45,6 +47,7 @@
         Pre_TermOfFemEquation.cpp
           Generate_Network.cpp
         Cal_GalerkinTermOfFemEquation.cpp
+        Cal_SmallFemTermOfFemEquation.cpp
         Cal_GlobalTermOfFemEquation.cpp
           Cal_IntegralQuantity.cpp
           Cal_AnalyticIntegration.cpp

=== Numeric/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.

=== contrib/Sparskit/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# GetDP - Copyright (C) 1997-2016 P. Dular and C. Geuzaine, University of Liege
+# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
 #
 # See the LICENSE.txt file for license information. Please report all
 # bugs and problems to the public mailing list <getdp@onelab.info>.

=== contrib/pewe/CMakeLists.txt ===
# GetDP - Copyright (C) 1997-2017 P. Dular and C. Geuzaine, University of Liege
#
# See the LICENSE.txt file for license information. Please report all
# bugs and problems to the public mailing list <getdp@onelab.info>.

set(SRC
    fortran/besselh.f90
    fortran/cylindrical_cavity.f90
    fortran/cylindrical_wall.f90
    fortran/cylindrical_walls.f90

   )

file(GLOB HDR RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)
append_getdp_src(contrib/pewe "${SRC};${HDR}")

=== debian/changelog ===
getdp (2.11.3+dfsg1-2build1) cosmic; urgency=medium

  * No-change rebuild against petsc 3.9

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 10 Aug 2018 17:27:08 +0000

getdp (2.11.3+dfsg1-2) unstable; urgency=medium

  * Team upload.
  * Debian patch link_fortran.patch: Ensure gfortran is always linked.
    Linking gfortran to LAPACK gave variable results: it didn't get
    added when built against ATLAS.
  * Apply upstream patches 5f171b22 and 8610fc15 to enable build
    against PETSc 3.9. Closes: #898325.
  * Don't build an rpath into binaries (activate CMAKE_SKIP_RPATH)
  * Standards-Version: 4.1.5

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Jul 2018 00:18:57 +0800

getdp (2.11.3+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * [d38e28c] New upstream version 2.11.3+dfsg1
  * [b40b549] Refresh patch
  * [c750307] Set compat-level 11
  * [4dd8d7b] Update VCS-field
  * [bc96935], [d73e945] Update d/copyright
  * [8765624] Remove banner to prevent privacy-breach
  * [e76dcd0] Update d/copyright
  * [1fe9192] Remove banner to prevent privacy-breach
  * [39ab84a] Remove myself from uploaders
  * [f1fd2b3] Set Standards-version 4.1.3
  * [096aad7] Update patch

 -- Anton Gladky <gladk@debian.org>  Wed, 28 Feb 2018 23:20:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,23 @@
 Source: getdp
 Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
-           Anton Gladky <gladk@debian.org> 
+Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>
 Section: math
-Priority: extra
+Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 11),
                gfortran,
                libarpack2-dev,
-               libgsl0-dev,
+               libgsl-dev,
                mpi-default-dev,
                petsc-dev,
                python-dev,
-               libslepc3.4.2-dev,
+               slepc-dev,
                swig,
                texlive,
                texlive-generic-recommended
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/getdp.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/getdp.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/science-team/getdp
+Vcs-Git: https://salsa.debian.org/science-team/getdp.git
 Homepage: http://www.geuz.org/getdp
 
 Package: getdp

=== debian/rules ===
--- 
+++ 
@@ -11,11 +11,11 @@
 export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0
-	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1
+	dh_auto_configure --builddirectory=$(BUILDDIR_PETSC) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=1 -DENABLE_SPARSKIT=0 -DCMAKE_SKIP_RPATH:BOOL=ON
+	dh_auto_configure --builddirectory=$(BUILDDIR_SPARSKIT) -O--parallel -- -DENABLE_MPI:BOOL=ON -DENABLE_PETSC=0 -DENABLE_SPARSKIT=1 -DCMAKE_SKIP_RPATH:BOOL=ON
 	sed -i 's/-lpthread/-lgfortran -lpthread/' debian/build/*/CMakeFiles/getdp.dir/link.txt
